create or replace package UDO_PKG_EQUIPDS_BASE as
 
  /*  -  "   ( ,  )" */
  NCMFL_STATUS_REGISTERED   constant PKG_STD.TNUMBER := 0; -- 
  NCMFL_STATUS_UPLOADING    constant PKG_STD.TNUMBER := 1; --   
  NCMFL_STATUS_UPLOADED     constant PKG_STD.TNUMBER := 2; --    
  NCMFL_STATUS_UPLOAD_ERR   constant PKG_STD.TNUMBER := 3; --    
  NCMFL_STATUS_SENDING      constant PKG_STD.TNUMBER := 4; --    
  NCMFL_STATUS_SENT         constant PKG_STD.TNUMBER := 5; --     
  NCMFL_STATUS_SEND_ERR     constant PKG_STD.TNUMBER := 6; --       

  /*  -   "   ( , )" */
  SCMML_TASK_TCF            constant PKG_STD.TSTRING := 'TCF'; -- TCF -    (Technical Condition Forecast)
  SCMML_TASK_RUL            constant PKG_STD.TSTRING := 'RUL'; -- RUL -    (Remaining Useful Life)
  SCMML_TASK_FP             constant PKG_STD.TSTRING := 'FP';  -- FP -   (Failure Predict)
  
  /*  -  "   ( , )" */
  NCMML_STATUS_REGISTERED   constant PKG_STD.TNUMBER := 0; -- 
  NCMML_STATUS_PROCESSING   constant PKG_STD.TNUMBER := 1; --   
  NCMML_STATUS_PROCESSED    constant PKG_STD.TNUMBER := 2; --    
  NCMML_STATUS_PROCESS_ERR  constant PKG_STD.TNUMBER := 3; --      

  /*    */
  function UTL_ACCESS_CHECK
  (
    SUSER                   in varchar2,      -- 
    STABLE                  in varchar2,      --  
    SACTION                 in varchar2,      --   
    NDOCUMENT               in number := null --   
  ) return                  boolean;          --   (false -  , true -  )

  /*    ( ) */
  procedure UTL_ACCESS
  (
    STABLE                  in varchar2,     --  
    SACTION                 in varchar2,     --   
    NDOCUMENT               in number :=null --   
  );
  
  /*          */
  function UTL_DATASET_MAKE_NAME
  (
    NDATASET_ID             in number,  --  
    DDATASET_TS             in date     --   
  ) return                  varchar2;   --   
  
  /*   "  "    */
  function GET
  (
    NFLAG_SMART             in number,             --      (0 - , 1 -  )
    NRN                     in number              --  
  ) return                  UDO_T_EQUIPDS%rowtype; --    

  /*  "  "   */
  procedure FIND_BY_CODE
  (
    NFLAG_SMART             in number,   --      (0 - , 1 -  )  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    NRN                     out number   --  
  );
  
  /*   "  " */
  procedure INS
  (
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  );

  /*   "  " */
  procedure UPD
  (
    NRN                     in number,   --  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2  -- 
  );

  /*   "  " */
  procedure DEL
  (
    NRN                     in number,  --  
    NCOMPANY                in number   -- 
  );
  
  /*   "   ( )"    */
  function CM_GET
  (
    NFLAG_SMART             in number,               --      (0 - , 1 -  )
    NRN                     in number                --  
  ) return                  UDO_T_EQUIPDSCM%rowtype; --     

  /*  "   ( )"    */
  procedure CM_FIND_BY_EQOBJKIND
  (
    NFLAG_SMART             in number,   --      (0 - , 1 -  )  
    NCOMPANY                in number,   -- 
    SEQOBJKIND              in varchar2, --   (  )
    NRN                     out number   --  
  );
  
  /*   "   ( )" */
  procedure CM_JOINS
  (
    NCOMPANY                in number,   -- 
    SEQOBJKIND              in varchar2, --  
    SDICMUNTS               in varchar2, --   
    SUSERPROCS_DATA         in varchar2, --  
    SEXSSERVICE_UPLOAD      in varchar2, --     
    SEXSSERVICEFN_UPLOAD    in varchar2, --     
    SEXSSERVICE_SEND_MD     in varchar2, --      
    SEXSSERVICEFN_SEND_MD   in varchar2, --      
    SEXSSERVICE_SEND_MDCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2, --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2, --      
    SEXSSERVICEFN_SEND_RQ   in varchar2, --      
    SEXSSERVICE_SEND_RQCB   in varchar2, --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2, --     Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2, --          
    SEXSSERVICEFN_FRCST_MD  in varchar2, --          
    NEQOBJKIND              out number,  -- .   
    NDICMUNTS               out number,  -- .    
    NUSERPROCS_DATA         out number,  -- .   
    NEXSSERVICEFN_UPLOAD    out number,  -- .      
    NEXSSERVICEFN_SEND_MD   out number,  -- .       
    NEXSSERVICEFN_SEND_MDCB out number,  -- .  call-back      
    NEXSSERVICEFN_SEND_RQ   out number,  -- .       
    NEXSSERVICEFN_SEND_RQCB out number,  -- .  call-back      
    NEXSSERVICEFN_FRCST_MD  out number   -- .           
  );
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,  -- 
    NEQOBJKIND              in number,  --  
    NDICMUNTS               in number,  --   
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --     
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_MDCB in number,  -- Call-back      
    NEXSSERVICEFN_SEND_RQ   in number,  --      
    NEXSSERVICEFN_SEND_RQCB in number,  -- Call-back      
    NEXSSERVICEFN_FRCST_MD  in number,  --          
    NRN                     out number  --  
  );
  
  /*   "   ( )" */  
  procedure CM_UPD
  (
    NRN                     in number,  --  
    NEQOBJKIND              in number,  --  
    NDICMUNTS               in number,  --       
    NUSERPROCS_DATA         in number,  --  
    NEXSSERVICEFN_UPLOAD    in number,  --     
    NEXSSERVICEFN_SEND_MD   in number,  --      
    NEXSSERVICEFN_SEND_MDCB in number,  -- Call-back      
    NEXSSERVICEFN_SEND_RQ   in number,  --      
    NEXSSERVICEFN_SEND_RQCB in number,  -- Call-back      
    NEXSSERVICEFN_FRCST_MD  in number   --          
  );
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number   --  
  );
  
  /*      "   ( )" */  
  procedure CM_SET_DATA_CONFIG
  (
    NRN                     in number,  --  
    BDATA_CONFIG            in clob     --   
  );
  
  /*   "   ( ,  )"    */
  function CMFL_GET
  (
    NFLAG_SMART             in number,                 --      (0 - , 1 -  )
    NRN                     in number                  --  
  ) return                  UDO_T_EQUIPDSCMFL%rowtype; --       
  
  /*   "   ( ,  )" */
  procedure CMFL_INS
  (
    NPRN                    in number,   -- 
    SFILE_NAME              in varchar2, --  
    SDESCR                  in varchar2, -- 
    BDATASET                in blob,     --      
    NDATASET_ID             in number,   --  
    DDATASET_TS             in date,     --       
    NRN                     out number   --  
  );
  
  /*   "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number   --  
  );  

  /*     "   ( ,  )" */  
  procedure CMFL_SET_FILE_NAME
  (
    NRN                     in number,  --  
    SFILE_NAME              in varchar2 --  
  );
  
  /*    "   ( ,  )" */  
  procedure CMFL_SET_STATUS
  (
    NRN                     in number,           --  
    NSTATUS                 in number,           --  (.  NCMFL_STATUS_*)
    SQUEUE_ID               in varchar2 := null, --   
    SERR                    in varchar2 := null  --   
  );

  /*   "   ( , )"    */
  function CMML_GET
  (
    NFLAG_SMART             in number,                 --      (0 - , 1 -  )
    NRN                     in number                  --  
  ) return                  UDO_T_EQUIPDSCMML%rowtype; --      
  
  /*  "   ( , )"   */
  procedure CMML_FIND_BY_TASK
  (
    NFLAG_SMART             in number,   --      (0 - , 1 -  )  
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (.  SCMML_TASK_*)
    NRN                     out number   --  
  );
  
  /*   "   ( , )" */
  procedure CMML_JOINS
  (
    SUSERPROCS_FRCST_DATA   in varchar2, --      
    NUSERPROCS_FRCST_DATA   out number   -- .       
  );
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (.  SCMML_TASK_*)
    NDATASET_ID             in number,   --  
    NUSERPROCS_FRCST_DATA   in number,   -- .       
    NRN                     out number   --  
  );
  
  /*   "   ( , )" */
  procedure CMML_UPD
  (
    NRN                     in number,   --  
    STASK                   in varchar2, --  (.  SCMML_TASK_*)
    NUSERPROCS_FRCST_DATA   in number    -- .       
  );
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number   --  
  );  

  /*    "   ( , )" */  
  procedure CMML_SET_PRECISION
  (
    NRN                     in number,  --  
    NPRECISION              in number   -- 
  );
  
  /*    "   ( , )" */  
  procedure CMML_SET_STATUS
  (
    NRN                     in number,           --  
    NSTATUS                 in number,           --  (.  NCMML_STATUS_*)
    SQUEUE_ID               in varchar2 := null, --   
    SERR                    in varchar2 := null  --   
  );
  
  /*     "   ( , )" */
  function CMML_TASK_NAME
  (
    STASK                   in varchar2 --  (.  SCMML_TASK_*)
  ) return                  varchar2;   --  
  
  /*     "   ( , )" */
  function CMML_TASK_HINT
  return                    varchar2;   --   

  /*         "   ( , )" */
  function CMML_USERPROCS_FRCST_DATA_HINT
  return                    varchar2;   --       
  
  /*         RUL- */  
  function CMML_RUL_BREAKDOWN_PROB
  (
    NFORECAST               in number,  -- RUL- (     )
    DFORECAST_DATE          in date,    --  
    DDATE                   in date     --  
  ) return                  number;     --  
  
  /*   "   ( , ,  )" */
  procedure CMMLH_INS
  (
    NPRN                    in number,   -- 
    NEQCONFIG               in number,   -- .   
    SRQ_AUTHID              in varchar2, -- ,  
    DRQ_DATE                in date,     -- / 
    BRQ                     in blob,     --  
    NRN                     out number   --  
  );

  /*   "   ( , ,  )" */
  procedure CMMLH_DEL
  (
    NRN                     in number   --  
  );
  
  /*     "   ( ,  ,  )" */  
  procedure CMMLH_SET_FORECAST
  (
    NRN                     in number,  --  
    BFORECAST               in blob     --  
  );

end UDO_PKG_EQUIPDS_BASE;
/
create or replace package body UDO_PKG_EQUIPDS_BASE as

  /* -   ,    */
  SROLE_ML_ADMIN            constant PKG_STD.TSTRING := 'ML_ADMIN';
  
  /*    */
  function UTL_ACCESS_CHECK
  (
    SUSER                   in varchar2,      -- 
    STABLE                  in varchar2,      --  
    SACTION                 in varchar2,      --   
    NDOCUMENT               in number := null --   
  ) return                  boolean           --   (false -  , true -  )
  is
  begin
    /*       */
    for C in (select UR.RN
                from USERROLES UR,
                     ROLES     R,
                     USERLIST  UL
               where UR.ROLEID = R.RN
                 and UR.AUTHID = UL.AUTHID
                 and UL.AUTHID = SUSER
                 and R.ROLENAME = SROLE_ML_ADMIN)
    loop
      /*   */
      return true;
    end loop;
    /*    */
    return false;
  end UTL_ACCESS_CHECK;
  
  /*    ( ) */
  procedure UTL_ACCESS
  (
    STABLE                  in varchar2,     --  
    SACTION                 in varchar2,     --   
    NDOCUMENT               in number :=null --   
  )
  is
  begin
    if (not UDO_PKG_EQUIPDS_BASE.UTL_ACCESS_CHECK(SUSER     => UTILIZER(),
                                                  STABLE    => STABLE,
                                                  SACTION   => SACTION,
                                                  NDOCUMENT => NDOCUMENT)) then
      P_EXCEPTION(0,
                  '        "%s"   "%s".',
                  SACTION,
                  STABLE);
    end if;
  end UTL_ACCESS;
  
  /*          */
  function UTL_DATASET_MAKE_NAME
  (
    NDATASET_ID             in number,  --  
    DDATASET_TS             in date     --   
  ) return                  varchar2    --   
  is
  begin
    return '' || TO_CHAR(NDATASET_ID) || '  ' || TO_CHAR(DDATASET_TS, 'dd.mm.yyyy hh24:mi:ss');
  end UTL_DATASET_MAKE_NAME;
  
  /*   "  "    */
  function GET
  (
    NFLAG_SMART             in number,             --      (0 - , 1 -  )
    NRN                     in number              --  
  ) return                  UDO_T_EQUIPDS%rowtype  --    
  is
    RES                     UDO_T_EQUIPDS%rowtype; --   
  begin
    /*   */
    begin
      select T.* into RES from UDO_T_EQUIPDS T where T.RN = NRN;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => NFLAG_SMART, NDOCUMENT => NRN, SUNIT_TABLE => 'UDO_T_EQUIPDS');
    end;
    /*   */
    return RES;
  end GET;
  
  /*  "  "   */
  procedure FIND_BY_CODE
  (
    NFLAG_SMART             in number,   --      (0 - , 1 -  )  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    NRN                     out number   --  
  )
  is
  begin
    /*   */
    begin
      select RN
        into NRN
        from UDO_T_EQUIPDS T
       where T.COMPANY = NCOMPANY
         and T.CODE = SCODE;
    exception
      when NO_DATA_FOUND then
        P_EXCEPTION(NFLAG_SMART,
                    '   "%s"  .',
                    SCODE);
    end;
  end FIND_BY_CODE;
  
  /*   "  " */
  procedure INS
  (
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2, -- 
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDS (RN, COMPANY, CODE, name) values (NRN, NCOMPANY, SCODE, SNAME);
  end INS;

  /*   "  " */
  procedure UPD
  (
    NRN                     in number,   --  
    NCOMPANY                in number,   -- 
    SCODE                   in varchar2, -- 
    SNAME                   in varchar2  -- 
  )
  is
  begin
    /*   */
    update UDO_T_EQUIPDS T
       set T.CODE = SCODE,
           T.NAME = SNAME
     where T.RN = NRN
       and T.COMPANY = NCOMPANY;
  end UPD;

  /*   "  " */
  procedure DEL
  (
    NRN                     in number,  --  
    NCOMPANY                in number   -- 
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDS T
     where T.RN = NRN
       and T.COMPANY = NCOMPANY;
  end DEL;
  
  /*   "   ( )"    */
  function CM_GET
  (
    NFLAG_SMART             in number,               --      (0 - , 1 -  )
    NRN                     in number                --  
  ) return                  UDO_T_EQUIPDSCM%rowtype  --     
  is
    RES                     UDO_T_EQUIPDSCM%rowtype; --   
  begin
    /*   */
    begin
      select T.* into RES from UDO_T_EQUIPDSCM T where T.RN = NRN;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => NFLAG_SMART, NDOCUMENT => NRN, SUNIT_TABLE => 'UDO_T_EQUIPDSCM');
    end;
    /*   */
    return RES;
  end CM_GET;

  /*  "   ( )"    */
  procedure CM_FIND_BY_EQOBJKIND
  (
    NFLAG_SMART             in number,    --      (0 - , 1 -  )  
    NCOMPANY                in number,    -- 
    SEQOBJKIND              in varchar2,  --   (  )
    NRN                     out number    --  
  )
  is
    NEQOBJKIND              PKG_STD.TREF; -- .   
  begin
    /*   */
    FIND_EQOBJKIND_FULLCODE(NFLAG_SMART  => NFLAG_SMART,
                            NFLAG_OPTION => 0,
                            NCOMPANY     => NCOMPANY,
                            SCODE        => SEQOBJKIND,
                            NRN          => NEQOBJKIND);
    /*   */
    begin
      select T.RN into NRN from UDO_T_EQUIPDSCM T where T.EQOBJKIND = NEQOBJKIND;
    exception
      when NO_DATA_FOUND then
        P_EXCEPTION(NFLAG_SMART,
                    '  "%s"     .',
                    SEQOBJKIND);
    end;
  end CM_FIND_BY_EQOBJKIND;
  
  /*   "   ( )" */
  procedure CM_JOINS
  (
    NCOMPANY                in number,    -- 
    SEQOBJKIND              in varchar2,  --  
    SDICMUNTS               in varchar2,  --   
    SUSERPROCS_DATA         in varchar2,  --  
    SEXSSERVICE_UPLOAD      in varchar2,  --     
    SEXSSERVICEFN_UPLOAD    in varchar2,  --     
    SEXSSERVICE_SEND_MD     in varchar2,  --      
    SEXSSERVICEFN_SEND_MD   in varchar2,  --      
    SEXSSERVICE_SEND_MDCB   in varchar2,  --     Call-back      
    SEXSSERVICEFN_SEND_MDCB in varchar2,  --      Call-back      
    SEXSSERVICE_SEND_RQ     in varchar2,  --      
    SEXSSERVICEFN_SEND_RQ   in varchar2,  --      
    SEXSSERVICE_SEND_RQCB   in varchar2,  --     Call-back      
    SEXSSERVICEFN_SEND_RQCB in varchar2,  --     Call-back      
    SEXSSERVICE_FRCST_MD    in varchar2,  --          
    SEXSSERVICEFN_FRCST_MD  in varchar2,  --              
    NEQOBJKIND              out number,   -- .   
    NDICMUNTS               out number,   -- .    
    NUSERPROCS_DATA         out number,   -- .   
    NEXSSERVICEFN_UPLOAD    out number,   -- .      
    NEXSSERVICEFN_SEND_MD   out number,   -- .       
    NEXSSERVICEFN_SEND_MDCB out number,   -- .  call-back      
    NEXSSERVICEFN_SEND_RQ   out number,   -- .       
    NEXSSERVICEFN_SEND_RQCB out number,   -- .  call-back      
    NEXSSERVICEFN_FRCST_MD  out number    -- .           
  )
  is
    NEXSSERVICE             PKG_STD.TREF; -- .   
  begin
    /*   */
    FIND_EQOBJKIND_FULLCODE(NFLAG_SMART  => 0,
                            NFLAG_OPTION => 0,
                            NCOMPANY     => NCOMPANY,
                            SCODE        => SEQOBJKIND,
                            NRN          => NEQOBJKIND);
    /*   */
    FIND_DICMUNTS_CODE(NFLAG_SMART  => 0,
                       NFLAG_OPTION => 0,
                       NCOMPANY     => NCOMPANY,
                       SMEAS_MNEMO  => SDICMUNTS,
                       NRN          => NDICMUNTS);
    /*   */
    if (SUSERPROCS_DATA is not null) then
      FIND_USERPROCS_CODE(NFLAG_SMART => 0, SCODE => SUSERPROCS_DATA, NRN => NUSERPROCS_DATA);
    else
      P_EXCEPTION(0, '     .');
    end if;
    /*      */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_UPLOAD, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_UPLOAD,
                           NRN          => NEXSSERVICEFN_UPLOAD);
    /*       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_MD, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_MD,
                           NRN          => NEXSSERVICEFN_SEND_MD);
    /* Call-back       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_MDCB, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_MDCB,
                           NRN          => NEXSSERVICEFN_SEND_MDCB);
    /*       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_RQ, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_RQ,
                           NRN          => NEXSSERVICEFN_SEND_RQ);
    /* Call-back       */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_SEND_RQCB, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_SEND_RQCB,
                           NRN          => NEXSSERVICEFN_SEND_RQCB);
    /*           */
    FIND_EXSSERVICE_CODE(NFLAG_SMART => 0, NFLAG_OPTION => 0, SCODE => SEXSSERVICE_FRCST_MD, NRN => NEXSSERVICE);
    FIND_EXSSERVICEFN_CODE(NFLAG_SMART  => 0,
                           NFLAG_OPTION => 0,
                           NEXSSERVICE  => NEXSSERVICE,
                           SCODE        => SEXSSERVICEFN_FRCST_MD,
                           NRN          => NEXSSERVICEFN_FRCST_MD);
  end CM_JOINS;
  
  /*      "   ( )" */
  procedure CM_CHECK
  (
    SMODE                   in varchar2,               -- 'I' - , 'U' - , 'D' - 
    RREC                    in UDO_T_EQUIPDSCM%rowtype --        
  )
  is
    /*   */
    RREC_OLD                UDO_T_EQUIPDSCM%rowtype;   --       
  
    /*     */
    function EXSSERVICE_TYPE
    (
      NEXSSERVICEFN         in number   -- .   
    ) return                number      --    (.  PKG_EXS.NSRV_TYPE_*)
    is
    begin
      /*     */
      for C in (select S.SRV_TYPE
                  from EXSSERVICE   S,
                       EXSSERVICEFN F
                 where F.RN = NEXSSERVICEFN
                   and F.PRN = S.RN)
      loop
        /*  -  */
        return C.SRV_TYPE;
      end loop;
      /*    */
      return null;
    end EXSSERVICE_TYPE;
    
    /*     */
    procedure EXSSERVICE_TYPE_CHECK
    (
      RREC                  in UDO_T_EQUIPDSCM%rowtype --  
    )
    is
    begin
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_UPLOAD) <> PKG_EXS.NSRV_TYPE_SEND) then
        P_EXCEPTION(0,
                    '        " ".');
      end if;
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_SEND_MD) <> PKG_EXS.NSRV_TYPE_SEND) then
        P_EXCEPTION(0,
                    '          " ".');
      end if;
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_SEND_MDCB) <> PKG_EXS.NSRV_TYPE_RECIVE) then
        P_EXCEPTION(0,
                    '             " ".');
      end if;
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_SEND_RQ) <> PKG_EXS.NSRV_TYPE_SEND) then
        P_EXCEPTION(0,
                    '         " ".');
      end if;
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_SEND_RQCB) <> PKG_EXS.NSRV_TYPE_RECIVE) then
        P_EXCEPTION(0,
                    '            " ".');
      end if;
      if (EXSSERVICE_TYPE(NEXSSERVICEFN => RREC.EXSSERVICEFN_FRCST_MD) <> PKG_EXS.NSRV_TYPE_RECIVE) then
        P_EXCEPTION(0,
                    '             " ".');
      end if;
    end EXSSERVICE_TYPE_CHECK;
  begin
    /*    */
    case SMODE
      /*  */
      when 'I' then
        begin
          /*      */
          EXSSERVICE_TYPE_CHECK(RREC => RREC);
        end;
      /*  */
      when 'U' then
        begin
          /*    */
          RREC_OLD := CM_GET(NFLAG_SMART => 0, NRN => RREC.RN);
          /*    ,    */
          if ((RREC.EQOBJKIND <> RREC_OLD.EQOBJKIND) or (RREC.DICMUNTS <> RREC_OLD.DICMUNTS)) then
            /*     */
            for C in (select T.RN from UDO_T_EQUIPDSCMFL T where T.PRN = RREC.RN)
            loop
              /*   -   */
              P_EXCEPTION(0,
                          '   (" ", "  ")  -        .');
            end loop;
          end if;
          /*      */
          EXSSERVICE_TYPE_CHECK(RREC => RREC);
        end;
      /*  */
      when 'D' then
        begin
          /*   ,                 */
          null;
        end;
      /*    */
      else
        P_EXCEPTION(0, '  "%s"  .', SMODE);
    end case;
  end CM_CHECK;
  
  /*   "   ( )" */
  procedure CM_INS
  (
    NPRN                    in number,               -- 
    NEQOBJKIND              in number,               --  
    NDICMUNTS               in number,               --   
    NUSERPROCS_DATA         in number,               --  
    NEXSSERVICEFN_UPLOAD    in number,               --     
    NEXSSERVICEFN_SEND_MD   in number,               --      
    NEXSSERVICEFN_SEND_MDCB in number,               -- Call-back      
    NEXSSERVICEFN_SEND_RQ   in number,               --      
    NEXSSERVICEFN_SEND_RQCB in number,               -- Call-back      
    NEXSSERVICEFN_FRCST_MD  in number,               --          
    NRN                     out number               --  
  )
  is
    RREC                    UDO_T_EQUIPDSCM%rowtype; --      
  begin
    /*   */
    RREC.PRN                    := NPRN;
    RREC.EQOBJKIND              := NEQOBJKIND;
    RREC.DICMUNTS               := NDICMUNTS;
    RREC.USERPROCS_DATA         := NUSERPROCS_DATA;
    RREC.EXSSERVICEFN_UPLOAD    := NEXSSERVICEFN_UPLOAD;
    RREC.EXSSERVICEFN_SEND_MD   := NEXSSERVICEFN_SEND_MD;
    RREC.EXSSERVICEFN_SEND_MDCB := NEXSSERVICEFN_SEND_MDCB;
    RREC.EXSSERVICEFN_SEND_RQ   := NEXSSERVICEFN_SEND_RQ;
    RREC.EXSSERVICEFN_SEND_RQCB := NEXSSERVICEFN_SEND_RQCB;
    RREC.EXSSERVICEFN_FRCST_MD  := NEXSSERVICEFN_FRCST_MD;
    /*    */
    CM_CHECK(SMODE => 'I', RREC => RREC);
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCM
      (RN,
       PRN,
       EQOBJKIND,
       DICMUNTS,
       DATA_CONFIG,
       USERPROCS_DATA,
       EXSSERVICEFN_UPLOAD,
       EXSSERVICEFN_SEND_MD,
       EXSSERVICEFN_SEND_MDCB,
       EXSSERVICEFN_SEND_RQ,
       EXSSERVICEFN_SEND_RQCB,
       EXSSERVICEFN_FRCST_MD)
    values
      (NRN,
       NPRN,
       NEQOBJKIND,
       NDICMUNTS,
       null,
       NUSERPROCS_DATA,
       NEXSSERVICEFN_UPLOAD,
       NEXSSERVICEFN_SEND_MD,
       NEXSSERVICEFN_SEND_MDCB,
       NEXSSERVICEFN_SEND_RQ,
       NEXSSERVICEFN_SEND_RQCB,
       NEXSSERVICEFN_FRCST_MD);
  end CM_INS;
  
  /*   "   ( )" */  
  procedure CM_UPD
  (
    NRN                     in number,               --  
    NEQOBJKIND              in number,               --  
    NDICMUNTS               in number,               --       
    NUSERPROCS_DATA         in number,               --  
    NEXSSERVICEFN_UPLOAD    in number,               --     
    NEXSSERVICEFN_SEND_MD   in number,               --      
    NEXSSERVICEFN_SEND_MDCB in number,               -- Call-back      
    NEXSSERVICEFN_SEND_RQ   in number,               --      
    NEXSSERVICEFN_SEND_RQCB in number,               -- Call-back      
    NEXSSERVICEFN_FRCST_MD  in number                --          
  )
  is
    RREC                    UDO_T_EQUIPDSCM%rowtype; --      
  begin
    /*   */
    RREC                        := CM_GET(NFLAG_SMART => 0, NRN => NRN);
    RREC.EQOBJKIND              := NEQOBJKIND;
    RREC.DICMUNTS               := NDICMUNTS;
    RREC.USERPROCS_DATA         := NUSERPROCS_DATA;
    RREC.EXSSERVICEFN_UPLOAD    := NEXSSERVICEFN_UPLOAD;
    RREC.EXSSERVICEFN_SEND_MD   := NEXSSERVICEFN_SEND_MD;
    RREC.EXSSERVICEFN_SEND_MDCB := NEXSSERVICEFN_SEND_MDCB;
    RREC.EXSSERVICEFN_SEND_RQ   := NEXSSERVICEFN_SEND_RQ;
    RREC.EXSSERVICEFN_SEND_RQCB := NEXSSERVICEFN_SEND_RQCB;
    RREC.EXSSERVICEFN_FRCST_MD  := NEXSSERVICEFN_FRCST_MD;
    /*    */
    CM_CHECK(SMODE => 'U', RREC => RREC);
    /*   */
    update UDO_T_EQUIPDSCM T
       set T.EQOBJKIND              = NEQOBJKIND,
           T.DICMUNTS               = NDICMUNTS,
           T.USERPROCS_DATA         = NUSERPROCS_DATA,
           T.EXSSERVICEFN_UPLOAD    = NEXSSERVICEFN_UPLOAD,
           T.EXSSERVICEFN_SEND_MD   = NEXSSERVICEFN_SEND_MD,
           T.EXSSERVICEFN_SEND_MDCB = NEXSSERVICEFN_SEND_MDCB,
           T.EXSSERVICEFN_SEND_RQ   = NEXSSERVICEFN_SEND_RQ,
           T.EXSSERVICEFN_SEND_RQCB = NEXSSERVICEFN_SEND_RQCB,
           T.EXSSERVICEFN_FRCST_MD  = NEXSSERVICEFN_FRCST_MD
     where T.RN = NRN;
  end CM_UPD;
  
  /*   "   ( )" */
  procedure CM_DEL
  (
    NRN                     in number                --  
  )
  is
    RREC                    UDO_T_EQUIPDSCM%rowtype; --      
  begin
    /*   */
    RREC := CM_GET(NFLAG_SMART => 0, NRN => NRN);
    /*    */
    CM_CHECK(SMODE => 'D', RREC => RREC);
    /*   */
    for C in (select T.RN from UDO_T_EQUIPDSCMFL T where T.PRN = NRN)
    loop
      CMFL_DEL(NRN => C.RN);
    end loop;
    /*   */
    for C in (select T.RN from UDO_T_EQUIPDSCMML T where T.PRN = NRN)
    loop
      CMML_DEL(NRN => C.RN);
    end loop;
    /*   */
    delete from UDO_T_EQUIPDSCM T where T.RN = NRN;
  end CM_DEL;
  
  /*      "   ( )" */  
  procedure CM_SET_DATA_CONFIG
  (
    NRN                     in number,  --  
    BDATA_CONFIG            in clob     --   
  )
  is
  begin
    /*     */
    update UDO_T_EQUIPDSCM T set T.DATA_CONFIG = BDATA_CONFIG where T.RN = NRN;
  end CM_SET_DATA_CONFIG;
  
  /*   "   ( ,  )"    */
  function CMFL_GET
  (
    NFLAG_SMART             in number,                 --      (0 - , 1 -  )
    NRN                     in number                  --  
  ) return                  UDO_T_EQUIPDSCMFL%rowtype  --       
  is
    RES                     UDO_T_EQUIPDSCMFL%rowtype; --   
  begin
    /*   */
    begin
      select T.* into RES from UDO_T_EQUIPDSCMFL T where T.RN = NRN;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => NFLAG_SMART, NDOCUMENT => NRN, SUNIT_TABLE => 'UDO_T_EQUIPDSCMFL');
    end;
    /*   */
    return RES;
  end CMFL_GET;
  
  /*   "   ( ,  )" */
  procedure CMFL_INS
  (
    NPRN                    in number,   -- 
    SFILE_NAME              in varchar2, --  
    SDESCR                  in varchar2, -- 
    BDATASET                in blob,     --  
    NDATASET_ID             in number,   --  
    DDATASET_TS             in date,     --   
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCMFL
      (RN, PRN, FILE_NAME, DESCR, QUEUE_ID, STATUS, ERR, DATASET, DATASET_ID, DATASET_TS)
    values
      (NRN, NPRN, SFILE_NAME, SDESCR, null, NCMFL_STATUS_REGISTERED, null, BDATASET, NDATASET_ID, DDATASET_TS);
  end CMFL_INS;
  
  /*   "   ( ,  )" */
  procedure CMFL_DEL
  (
    NRN                     in number                  --  
  )
  is
    RREC                    UDO_T_EQUIPDSCMFL%rowtype; --  
  begin
    /*   */
    RREC := CMFL_GET(NFLAG_SMART => 0, NRN => NRN);
    /*     : ,    ,    ,     ,        */
    if (RREC.STATUS not in (NCMFL_STATUS_REGISTERED,
                            NCMFL_STATUS_UPLOADED,
                            NCMFL_STATUS_UPLOAD_ERR,
                            NCMFL_STATUS_SENT,
                            NCMFL_STATUS_SEND_ERR)) then
      P_EXCEPTION(0, '  ,  .');
    end if;
    /* ,    / ,  -      */
    for C in (select T.RN
                from UDO_T_EQUIPDSCMML T
               where T.DATASET_ID = RREC.DATASET_ID
                 and T.STATUS <> NCMML_STATUS_REGISTERED)
    loop
      P_EXCEPTION(0,
                  '   ,      "".    .');
    end loop;
    /*     */
    for C in (select T.RN from UDO_T_EQUIPDSCMML T where T.DATASET_ID = RREC.DATASET_ID)
    loop
      CMML_DEL(NRN => C.RN);
    end loop;
    /*   */
    delete from UDO_T_EQUIPDSCMFL T where T.RN = NRN;
  end CMFL_DEL;

  /*     "   ( ,  )" */  
  procedure CMFL_SET_FILE_NAME
  (
    NRN                     in number,  --  
    SFILE_NAME              in varchar2 --  
  )
  is
  begin
    /*    */
    update UDO_T_EQUIPDSCMFL T set T.FILE_NAME = SFILE_NAME where T.RN = NRN;
  end CMFL_SET_FILE_NAME;
  
  /*    "   ( ,  )" */  
  procedure CMFL_SET_STATUS
  (
    NRN                     in number,                    --  
    NSTATUS                 in number,                    --  (.  NCMFL_STATUS_*)
    SQUEUE_ID               in varchar2 := null,          --   
    SERR                    in varchar2 := null           --   
  )
  is
    SQUEUE_ID_              PKG_STD.TSTRING := SQUEUE_ID; --     
    SERR_                   PKG_STD.TSTRING := SERR;      --     
  begin
    /*    */
    if ((NSTATUS in (NCMFL_STATUS_SENDING, NCMFL_STATUS_SENT)) and (SQUEUE_ID_ is null)) then
      P_EXCEPTION(0,
                  '          "   ", "    ".');
    end if;
    /*     */
    if ((NSTATUS in (NCMFL_STATUS_UPLOAD_ERR, NCMFL_STATUS_SEND_ERR)) and (SERR_ is null)) then
      P_EXCEPTION(0,
                  '           "   ", "    ".');
    end if;
    /*           ,     */
    if (NSTATUS not in (NCMFL_STATUS_SENDING, NCMFL_STATUS_SENT)) then
      SQUEUE_ID_ := null;
    end if;
    if (NSTATUS not in (NCMFL_STATUS_UPLOAD_ERR, NCMFL_STATUS_SEND_ERR)) then
      SERR_ := null;
    end if;
    /*       */
    update UDO_T_EQUIPDSCMFL T
       set T.STATUS   = NSTATUS,
           T.QUEUE_ID = SQUEUE_ID_,
           T.ERR      = SERR_
     where T.RN = NRN;
  end CMFL_SET_STATUS;

  /*   "   ( , )"    */
  function CMML_GET
  (
    NFLAG_SMART             in number,                 --      (0 - , 1 -  )
    NRN                     in number                  --  
  ) return                  UDO_T_EQUIPDSCMML%rowtype  --      
  is
    RES                     UDO_T_EQUIPDSCMML%rowtype; --   
  begin
    /*   */
    begin
      select T.* into RES from UDO_T_EQUIPDSCMML T where T.RN = NRN;
    exception
      when NO_DATA_FOUND then
        PKG_MSG.RECORD_NOT_FOUND(NFLAG_SMART => NFLAG_SMART, NDOCUMENT => NRN, SUNIT_TABLE => 'UDO_T_EQUIPDSCMML');
    end;
    /*   */
    return RES;
  end CMML_GET;
  
  /*  "   ( , )"   */
  procedure CMML_FIND_BY_TASK
  (
    NFLAG_SMART             in number,   --      (0 - , 1 -  )  
    NPRN                    in number,   -- 
    STASK                   in varchar2, --  (.  SCMML_TASK_*)
    NRN                     out number   --  
  )
  is
  begin
    /*   */
    begin
      select T.RN
        into NRN
        from UDO_T_EQUIPDSCMML T
       where T.PRN = NPRN
         and T.TASK = STASK;
    exception
      when NO_DATA_FOUND then
        P_EXCEPTION(NFLAG_SMART,
                    '   "%s"    "%s"  .',
                    STASK,
                    TO_CHAR(NPRN));
    end;
  end CMML_FIND_BY_TASK;
  
  /*   "   ( , )" */
  procedure CMML_JOINS
  (
    SUSERPROCS_FRCST_DATA   in varchar2, --      
    NUSERPROCS_FRCST_DATA   out number   -- .       
  )
  is
  begin
    /*      */
    if (SUSERPROCS_FRCST_DATA is not null) then
      FIND_USERPROCS_CODE(NFLAG_SMART => 0, SCODE => SUSERPROCS_FRCST_DATA, NRN => NUSERPROCS_FRCST_DATA);
    else
      P_EXCEPTION(0,
                  '      .');
    end if;
  end CMML_JOINS;
  
  /*   "   ( , )" */
  procedure CMML_INS
  (
    NPRN                    in number,       -- 
    STASK                   in varchar2,     --  (.  SCMML_TASK_*)
    NDATASET_ID             in number,       --  
    NUSERPROCS_FRCST_DATA   in number,       -- .       
    NRN                     out number       --  
  )
  is
    NCNT                    PKG_STD.TNUMBER; --    
  begin
    /*        */
    begin
      select count(T.RN)
        into NCNT
        from UDO_T_EQUIPDSCMFL T
       where T.PRN = NPRN
         and T.DATASET_ID = NDATASET_ID;
    exception
      when others then
        P_EXCEPTION(0,
                    '     .');
    end;
    if (NCNT = 0) then
      P_EXCEPTION(0,
                  '    (%s).',
                  COALESCE(TO_CHAR(NDATASET_ID), '< >'));
    end if;
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCMML
      (RN, PRN, TASK, PRECISION, QUEUE_ID, STATUS, ERR, DATASET_ID, USERPROCS_FRCST_DATA)
    values
      (NRN, NPRN, STASK, null, null, NCMML_STATUS_REGISTERED, null, NDATASET_ID, NUSERPROCS_FRCST_DATA);
  end CMML_INS;
  
  /*   "   ( , )" */
  procedure CMML_UPD
  (
    NRN                     in number,                 --  
    STASK                   in varchar2,               --  (.  SCMML_TASK_*)
    NUSERPROCS_FRCST_DATA   in number                  -- .       
  )
  is
    RREC                    UDO_T_EQUIPDSCMML%rowtype; --  
  begin
    /*   */
    RREC := CMML_GET(NFLAG_SMART => 0, NRN => NRN);
    /*     : ,       */
    if (RREC.STATUS not in (NCMML_STATUS_REGISTERED, NCMML_STATUS_PROCESS_ERR)) then
      P_EXCEPTION(0,
                  '     ,  .');
    end if;
    /*   */
    update UDO_T_EQUIPDSCMML T
       set T.TASK                 = STASK,
           T.USERPROCS_FRCST_DATA = NUSERPROCS_FRCST_DATA
     where T.RN = NRN;
  end CMML_UPD;
  
  /*   "   ( , )" */
  procedure CMML_DEL
  (
    NRN                     in number                  --  
  )
  is
    RREC                    UDO_T_EQUIPDSCMML%rowtype; --  
  begin
    /*   */
    RREC := CMML_GET(NFLAG_SMART => 0, NRN => NRN);
    /*     : ,    ,       */
    if (RREC.STATUS not in (NCMML_STATUS_REGISTERED, NCMML_STATUS_PROCESSED, NCMML_STATUS_PROCESS_ERR)) then
      P_EXCEPTION(0, ' ,  .');
    end if;
    /*   */
    for C in (select T.RN from UDO_T_EQUIPDSCMMLH T where T.PRN = NRN)
    loop
      CMMLH_DEL(NRN => C.RN);
    end loop;
    /*   */
    delete from UDO_T_EQUIPDSCMML T where T.RN = NRN;
  end CMML_DEL;

  /*    "   ( , )" */  
  procedure CMML_SET_PRECISION
  (
    NRN                     in number,  --  
    NPRECISION              in number   -- 
  )
  is
  begin
    /*   */
    update UDO_T_EQUIPDSCMML T set T.PRECISION = NPRECISION where T.RN = NRN;
  end CMML_SET_PRECISION;
  
  /*    "   ( , )" */  
  procedure CMML_SET_STATUS
  (
    NRN                     in number,                    --  
    NSTATUS                 in number,                    --  (.  NCMML_STATUS_*)
    SQUEUE_ID               in varchar2 := null,          --   
    SERR                    in varchar2 := null           --   
  )
  is
    SQUEUE_ID_              PKG_STD.TSTRING := SQUEUE_ID; --     
    SERR_                   PKG_STD.TSTRING := SERR;      --     
  begin
    /*    */
    if ((NSTATUS in (NCMML_STATUS_PROCESSING, NCMML_STATUS_PROCESSED)) and (SQUEUE_ID_ is null)) then
      P_EXCEPTION(0,
                  '         "  ", "   ".');
    end if;
    /*     */
    if ((NSTATUS in (NCMML_STATUS_PROCESS_ERR)) and (SERR_ is null)) then
      P_EXCEPTION(0,
                  '          "   ".');
    end if;
    /*           ,     */
    if (NSTATUS not in (NCMML_STATUS_PROCESSING, NCMML_STATUS_PROCESSED)) then
      SQUEUE_ID_ := null;
    end if;
    if (NSTATUS not in (NCMML_STATUS_PROCESS_ERR)) then
      SERR_ := null;
    end if;
    /*       */
    update UDO_T_EQUIPDSCMML T
       set T.STATUS   = NSTATUS,
           T.QUEUE_ID = SQUEUE_ID_,
           T.ERR      = SERR_
     where T.RN = NRN;
  end CMML_SET_STATUS;
  
  /*     "   ( , )" */
  function CMML_TASK_NAME
  (
    STASK                   in varchar2 --  (.  SCMML_TASK_*)
  ) return                  varchar2    --  
  is
  begin
    case STASK
      when SCMML_TASK_TCF then
        return '  ';
      when SCMML_TASK_RUL then
        return '  ';
      when SCMML_TASK_FP then
        return ' ';
      else
        return '    ';
    end case;
  end CMML_TASK_NAME;
  
  /*     "   ( , )" */
  function CMML_TASK_HINT
  return                    varchar2    --   
  is
  begin
    return '<b>TCF</b> - ' || CMML_TASK_NAME(STASK => SCMML_TASK_TCF) || ' (<b>T</b>echnical <b>C</b>ondition <b>F</b>orecast)<br>' ||
           '<b>RUL</b> - ' || CMML_TASK_NAME(STASK => SCMML_TASK_RUL) || ' (<b>R</b>emaining <b>U</b>seful <b>L</b>ife)<br>' ||
           '<b>FP</b> - ' || CMML_TASK_NAME(STASK => SCMML_TASK_FP) || ' (<b>F</b>ailure <b>P</b>redict)';
  end CMML_TASK_HINT;
  
  /*         "   ( , )" */
  function CMML_USERPROCS_FRCST_DATA_HINT
  return                    varchar2    --       
  is
  begin
    return '     .       .<br>' ||
           '  <b>  "NEQCONFIG"</b> -       .   .<br>' ||
           '  <b>  "NDATASET_IDENT", "NDATASET_CONFIG_IDENT"  "NREQUEST_CONFIG_IDENT"</b> - ' ||
           '      (CSV),    (XML)     (XML)    .';
  end CMML_USERPROCS_FRCST_DATA_HINT;
  
  /*         RUL- */  
  function CMML_RUL_BREAKDOWN_PROB
  (
    NFORECAST               in number,       -- RUL- (     )
    DFORECAST_DATE          in date,         --  
    DDATE                   in date          --  
  ) return                  number           --  
  is
    NRES                    PKG_STD.TNUMBER; --   
  begin
    /*   */
    if ((NFORECAST is null) or (DFORECAST_DATE is null) or (DDATE is null) or (DDATE < DFORECAST_DATE) or
       (DFORECAST_DATE > sysdate) or (DDATE < sysdate)) then
      return null;
    end if;
    /*    */
    if (NFORECAST = 0) or ((DDATE - sysdate) = 0) then
      return 100;
    end if;
    if (sysdate + NFORECAST > DDATE) then
      return 0;
    end if;
    /*  */
    NRES := 100 - ROUND((NFORECAST - (TRUNC(sysdate) - TRUNC(DFORECAST_DATE))) / (DDATE - sysdate) * 100);
    /*   */
    if (NRES > 100) then
      NRES := 100;
    end if;
    if (NRES < 0) then
      NRES := 0;
    end if;
    /*   */
    return NRES;
  end CMML_RUL_BREAKDOWN_PROB;
  
  /*   "   ( , ,  )" */
  procedure CMMLH_INS
  (
    NPRN                    in number,   -- 
    NEQCONFIG               in number,   -- .   
    SRQ_AUTHID              in varchar2, -- ,  
    DRQ_DATE                in date,     -- / 
    BRQ                     in blob,     --  
    NRN                     out number   --  
  )
  is
  begin
    /*  .  */
    NRN := GEN_ID();
    /*   */
    insert into UDO_T_EQUIPDSCMMLH
      (RN, PRN, EQCONFIG, RQ_AUTHID, RQ_DATE, RQ, FORECAST)
    values
      (NRN, NPRN, NEQCONFIG, SRQ_AUTHID, DRQ_DATE, BRQ, null);
  end CMMLH_INS;
  
  /*   "   ( , ,  )" */
  procedure CMMLH_DEL
  (
    NRN                     in number   --  
  )
  is
  begin
    /*   */
    delete from UDO_T_EQUIPDSCMMLH T where T.RN = NRN;
  end CMMLH_DEL;
  
  /*     "   ( ,  ,  )" */  
  procedure CMMLH_SET_FORECAST
  (
    NRN                     in number,  --  
    BFORECAST               in blob     --  
  )
  is
  begin
    /*    */
    update UDO_T_EQUIPDSCMMLH T set T.FORECAST = BFORECAST where T.RN = NRN;
  end CMMLH_SET_FORECAST;
  
end UDO_PKG_EQUIPDS_BASE;
/
